package link;

import exeptions.LinkAlreadyExists;

import java.util.Optional;
import java.util.Set;

public class LinkRepository {

	final private LinkPersistenceAdapter linkPersistenceAdapter;
	final private Set<Link> links;

	public LinkRepository(LinkPersistenceAdapter linkPersistenceAdapter) {
		this.linkPersistenceAdapter = linkPersistenceAdapter;
		this.links = linkPersistenceAdapter.getAll();
	}

	public Optional<Link> getById(LinkId id) {
		return links.stream().filter(link -> link.getId().equals(id)).findFirst();
	}

	public Optional<Link> getByUrl(LinkUrl url) {
		return links.stream().filter(link -> link.getUrl().equals(url)).findFirst();
	}

	public void add(Link link) {
		checkDuplicates(link);


	}

	private void checkDuplicates(Link newLink) {
		if (this.getById(newLink.getId()).isPresent()) {
			throw new LinkAlreadyExists("A link with the id " + newLink.getId() + " already exitsts");
		}

		if (this.getByUrl(newLink.getUrl()).isPresent()) {
			throw new LinkAlreadyExists("A link with the url " + newLink.getUrl() + " already exitsts");
		}
	}
}
